---
title: 🔌 Integrations
---

***

### 🧬 Embedding Integrations

Embeddings are the A.I-native way to represent any kind of data, making them the perfect fit for working with all kinds of A.I-powered tools and algorithms. They can represent text, images, and soon audio and video. There are many options for creating embeddings, whether locally using an installed library, or by calling an API.

Chroma provides lightweight wrappers around popular embedding providers, making it easy to use them in your apps. You can set an embedding function when you create a Chroma collection, which will be used automatically, or you can call them directly yourself.

{% special_table %}
{% /special_table %}

|              | Python | JS |
|--------------|-----------|---------------|
| [OpenAI](/integrations/openai) | ✅  | ✅ |
| [Google Gemini](/integrations/google-gemini) | ✅  | ✅ |
| [Cohere](/integrations/cohere) | ✅  | ✅ |
| [Hugging Face](/integrations/hugging-face) | ✅  | ➖ |
| [Instructor](/integrations/instructor) | ✅  | ➖ |
| [Hugging Face Embedding Server](/integrations/hugging-face-server) | ✅  | ✅ |
| [Jina AI](/integrations/jinaai) | ✅  | ✅ |
| [Roboflow](/integrations/roboflow) | ✅  | ➖ |
| [Ollama Embeddings](/integrations/ollama) | ✅  | ✅ |


***

### 🏗️ Framework Integrations

Chroma maintains integrations with many popular tools. These tools can be used to define the business logic of an AI-native application, curate data, fine-tune embedding spaces and more.

We welcome pull requests to add new Integrations to the community.

{% special_table %}
{% /special_table %}

|              | Python | JS |
|--------------|-----------|---------------|
| [🦜️🔗 Langchain](/integrations/langchain) | ✅  | ✅ |
| [🦙 LlamaIndex](/integrations/llamaindex) | ✅  | ✅ |
| [Braintrust](/integrations/braintrust) | ✅  | ✅ |
| [🔭 OpenLLMetry](/integrations/openllmetry) | ✅     | 🔜 |
| [🎈 Streamlit](/integrations/streamlit) | ✅     | ➖ |
| [💙 Haystack](/integrations/haystack) | ✅     | ➖ |
| [🔭 OpenLIT](/integrations/openlit) | ✅     | 🔜 |
